#include <OneWire.h>
// #include <LiquidCrystal.h>
#include <Wire.h> 
//#include <LiquidCrystal_I2C.h>

/***************************************************************************** 
 * Sketch: DS18B20_LCD.pde
 * Author: A. Kriwanek
 * Version: 1.0  02.04.2011/10:00
 * based on OneWire Library 2.0 from http://www.pjrc.com/teensy/td_libs_OneWire.html
 * and the provided example sketch.
 * (Authors: Jim Studt, Tom Pollard, "RJL20", Robin James, Paul Stoffregen)
 *
 * Digital Pin 12 for 1Wire bus
 * Pull Up Resistor 4k7 between Digital Pin 12 and +5V
 * Temperature sensor(s) Dallas 18B20 for testing
 *
 * This sketch searches for Dallas 1Wire temperature sensors. If a sensor is found,
 * the hardware id, the data from scratchpad and the actual temperature is transmitted
 * via the serial interface. Additionally the values are displayed on the LCD.
 *
 *
 * This sketch is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 *****************************************************************************/

//LiquidCrystal_I2C lcd(0x20,20,2);
byte saa1064 = 0x70 >> 1;           // define the I2C bus address for our SAA1064 (pin 1 to GND)
int digits[14]={
63, 6, 91, 79, 102, 109, 125,7, 127, 111, 225, 0, 119, 28}; // 204 original Schrank, 225 Platine SAA1064
// these are the byte representations of pins required to display each digit 0~9, °C sign, and blank digit, A, u
// right hand digit 180° flip - DP ist used as ° symbol :-) 204 is °c for big C use 143
OneWire  ds(12);                      // 1Wire Instance on Arduino digital pin 12
// LiquidCrystal lcd(8, 9, 4, 5, 6, 7);  // LCD instance
// Define some values used by the panel and buttons:

byte i;
byte present = 0;
byte data[12];
byte addr[8];
float Temp;

void setup() {
//  Serial.begin(9600);            // Start serial interface with 9600 Baud
//  lcd.init();      // Start the LCD library for 2x16 display
//  lcd.backlight();
//  lcd.setCursor(0,0);
//  lcd.print(" TESTPROGRAMM ");
//  lcd.setCursor(0,1);
//  lcd.print(" Dallas DS18B20 ");
//  delay(1000);
//  lcd.clear();
//}
//{
 Wire.begin(); // start up I2C bus
 delay(100);
 initDisplay();
 }
void initDisplay()
// turns on dynamic mode and adjusts segment current to 2mA
{
Wire.beginTransmission(saa1064);
Wire.write(B00000000); // this is the instruction byte. Zero means the next byte is the control byte
Wire.write(B00010111); // control byte (dynamic mode on, digits 1+3 on, digits 2+4 on, 21mA segment current
// left 111 is relevant for current left hand "1" 12mA, middle 6mA and right 3mA - so you can tewak it
Wire.endTransmission();
}
//void ClearDisplay()
//{
//Wire.beginTransmission(saa1064);
//Wire.write(1); // start with digit 1 (right-hand side)
//Wire.write(0); // blank digit 1
//Wire.write(0); // blank digit 2
//Wire.write(0); // blank digit 3
//Wire.write(0); // blank digit 4
//Wire.endTransmission();
//}
void displayInteger(int num, int zero)
{
int hundred, ten, one;
// breakdown number into columns
hundred = num/100;
ten = (num-(hundred*100))/10; 
one = num-((hundred*100)+(ten*10));
if (zero==1) // yes to leading zero
{
Wire.beginTransmission(saa1064);
Wire.write(1);
Wire.write(digits[hundred]);
Wire.write(digits[ten]+128); // 128 turns on DP
Wire.write(digits[one]);
Wire.write(digits[10]);     // print position 10 from arry - °C
Wire.endTransmission();
delay(10);
}
else
if (zero==0)                // no to leading zero
{
if (hundred==0) { hundred=11; }
if (hundred==0 && num<100) { hundred=16; }
if (ten==0 && num<10) { ten=16; }
Wire.beginTransmission(saa1064);
Wire.write(1);
Wire.write(digits[hundred]);
Wire.write(digits[ten]+128);
Wire.write(digits[one]);
Wire.write(digits[10]);
Wire.endTransmission();
delay(10);
}}

void loop(void) {
  if ( !ds.search(addr)) {
    // No more Dallas chips present:
//    Serial.print("No more addresses.\n");
    ds.reset_search();
    delay(250);
    return;
  }

  // Output 64 Bit hardware id of Dallas Chip:
//  Serial.print("R=");
  for( i = 0; i < 8; i++) {
 //   Serial.print(addr[i], HEX);
 //   Serial.print(" ");
  }

  // Check for invalid CRC in address:
  if ( OneWire::crc8( addr, 7) != addr[7]) {
 //   Serial.print("CRC is not valid!\n");
    return;
  }

  // Check for family code which is not DS18B20:
  if ( addr[0] != 0x28) {
//    Serial.print("Device is not a DS18B20 family device.\n");
    return;
  }

  // The DallasTemperature library can do all this work for you!
  ds.reset();
  ds.select(addr);
  ds.write(0x44,0);          // start conversion, with parasite power off

  delay(100);               // maybe 750ms is enough, maybe not

  // Check whether chip is present:
  present = ds.reset();
  ds.select(addr);    
  ds.write(0xBE);             // Read Scratchpad

//  Serial.print("P=");         // Present = 1
//  Serial.print(present,HEX);
//  Serial.print(" ");
  for ( i = 0; i < 9; i++) {   // we need 9 bytes of data
    data[i] = ds.read();
//    Serial.print(data[i], HEX);
//    Serial.print(" ");
  }
//  Serial.print(" CRC=");
//  Serial.print( OneWire::crc8( data, 8), HEX);
  // Calculate temperature. data[1] High Byte, data[0] Low Byte.
  Temp =  ((data[1] << 8) + data[0] ) * 0.0625;  // 12Bit = 0,0625 C per Bit
//  Serial.print( " T=");
//  Serial.print( Temp, 2);
//  Serial.print( " C");
//  Serial.println();
  display_1WSensor();
}

void display_1WSensor(){
  // display Sensor data on LCD:
  char line[17];
  // Hardware ID:
  sprintf(line, "%02X%02X%02X%02X%02X%02X%02X%02X", addr[0], addr[1], addr[2], addr[3], addr[4], addr[5], addr[6], addr[7]);
//  lcd.setCursor(0,0);         // move to the begining of the second line
//  lcd.print(line);
  // Temperature in Hex:
//  lcd.setCursor(0,1);
  sprintf(line, "D=%02X%02X", data[1], data[0]);
//  lcd.print(line);
  // Temperature as Degree Celsius:
//  lcd.setCursor(7,1); 
 // sprintf(line, "T=%f C", Temp); // funktioniert nicht, Fehler in Compiler?
  dtostrf(Temp, 5, 2, line);  // funktionierende Alterntative: http://dereenigne.org/electronics/arduino/arduino-float-to-string
//  lcd.print("T=");
//  lcd.print(line);
//  lcd.print(" C");
  
  displayInteger(Temp * 10 ,0); 
}


